/*
 * Copyright (C) 2012 Samsung Electronics
 * Copyright (C) 2012 Intel Corporation. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; see the file COPYING.LIB.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

/**
 * @file    EWebKit2.h
 * @brief   Contains the header files that are required by WebKit2-EFL.
 *
 * It includes the all header files that are exported to public API.
 */

#ifndef EWebKit2_h
#define EWebKit2_h

#include "ewk_auth_request.h"
#include "ewk_back_forward_list.h"
#include "ewk_back_forward_list_item.h"
#include "ewk_color_picker.h"
#include "ewk_context.h"
#include "ewk_context_menu.h"
#include "ewk_context_menu_item.h"
#include "ewk_cookie_manager.h"
#include "ewk_database_manager.h"
#include "ewk_download_job.h"
#include "ewk_error.h"
#include "ewk_favicon_database.h"
#include "ewk_file_chooser_request.h"
#include "ewk_form_submission_request.h"
#include "ewk_main.h"
#include "ewk_navigation_data.h"
#include "ewk_navigation_policy_decision.h"
#include "ewk_object.h"
#include "ewk_page_group.h"
#include "ewk_popup_menu.h"
#include "ewk_popup_menu_item.h"
#include "ewk_security_origin.h"
#include "ewk_settings.h"
#include "ewk_storage_manager.h"
#include "ewk_text_checker.h"
#include "ewk_touch.h"
#include "ewk_url_request.h"
#include "ewk_url_response.h"
#include "ewk_url_scheme_request.h"
#include "ewk_view.h"
#include "ewk_window_features.h"

#endif // EWebKit2_h
